## toppic 1.7.10+cleaned1

=== CMakeLists.txt ===
#specify the version being used as well as the language
cmake_minimum_required(VERSION 3.1)
#Name your project here
project(TopPIC)

SET(CMAKE_VERBOSE_MAKEFILE ON)

SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/../bin)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  # Linux specific code
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-unknown-pragmas -std=c++17 -Wl,-rpath=$ORIGIN/../lib/toppic,--disable-new-dtags -O3 -DWITHOUT_MZ5 -fPIC")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux") 

IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  # Windows specific code
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-unknown-pragmas -std=c++17 -O3 -DWITHOUT_MZ5 -fPIC -fpermissive")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

# The options c++14 and mavx are set for the frugally-deep library
message(STATUS "system name " ${CMAKE_SYSTEM_NAME})

# for Qt
set(CMAKE_AUTOMOC ON)
SET(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
find_package(Qt5Widgets)
find_package(Qt5Core)
find_package(Qt5Gui)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  # Linux specific code
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DTOPPIC_LINUX")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux") 

IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  # Windows specific code
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DTOPPIC_WINDOWS -DWIN32")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext
                    ${Qt5Widgets_INCLUDE_DIRS}
                    ${Qt5Core_INCLUDE_DIRS}
                    ${Qt5Gui_INCLUDE_DIRS})
link_directories(${CMAKE_CURRENT_SOURCE_DIR}/lib/toppic)

message(STATUS "cmake cxx flags " ${CMAKE_CXX_FLAGS})

# pwiz
file(GLOB PWIZ_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/utility/minimxml/*.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/utility/misc/*.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/data/common/*.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/data/msdata/*.cpp)
# nowide
file(GLOB NOWIDE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/ext/boost/nowide/*.cpp)

# hts
file(GLOB HTS_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/ext/htslib/*.c)

# common
file(GLOB_RECURSE COMMON_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/common/*.cpp)
file(GLOB SEQ_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/seq/*.cpp)
file(GLOB PARA_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/para/*.cpp)
file(GLOB SPEC_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/spec/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/msmap/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/factory/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/env/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/feature/*.cpp)
file(GLOB MZML_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/mzml/*.cpp)
file(GLOB PRSM_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/prsm/*.cpp)

# classes for topfd 
file(GLOB_RECURSE TOPFD_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/topfd/*.cpp)

# topfd console 
file(GLOB TOPFD_CONSOLE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topfd_argument.cpp
                             ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topfd.cpp)

# topfd gui
file(GLOB TOPFD_GUI_SRCS    ${CMAKE_CURRENT_SOURCE_DIR}/src/topfd/common/topfd_para.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topfd/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topfd/*.qrc)

# topfd_single console main
file(GLOB TOPFD_SINGLE_PROC_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topfd_single_process.cpp)
file(GLOB TOPFD_SINGLE_CONSOLE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topfd_single_argument.cpp
                                    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topfd_single.cpp)
 
# classes for toppic
file(GLOB_RECURSE FILTER_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/filter/*.cpp)

file(GLOB SEARCH_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/search/diag/*.cpp 
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/zeroptmsearch/*.cpp
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/oneptmsearch/*.cpp
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/varptmsearch/*.cpp
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/ptmsearch/*.cpp
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/duplicatematch/*.cpp)

file(GLOB TDGF_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/count/*.cpp
                      ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/tdgf/*.cpp)
file(GLOB LOCAL_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/local/*.cpp)
file(GLOB VISUAL_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/visual/*.cpp)

# toppic console main
file(GLOB TOPPIC_PROC_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/console/toppic_process.cpp
		                  	    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/toppic_argument.cpp
		                  	    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/console_util.cpp)

file(GLOB TOPPIC_CONSOLE_SRCS	${CMAKE_CURRENT_SOURCE_DIR}/src/console/toppic.cpp)

# toppic gui main
file(GLOB TOPPIC_GUI_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/toppic/*.cpp
	                  		    ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/toppic/*.qrc
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/console/toppic_argument.cpp
		                  	    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/console_util.cpp)

# classes for topmg
file(GLOB GRAPH_ALIGN_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/search/diag/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/search/graph/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/search/graphalign/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/search/duplicatematch/*.cpp)

file(GLOB MCMC_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/count/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/mcmc/*.cpp)

# topmg console main
file(GLOB TOPMG_PROC_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topmg_process.cpp
	                  		    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topmg_argument.cpp
                      			${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex_file_name.cpp
		                  	    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/console_util.cpp)

file(GLOB TOPMG_CONSOLE_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topmg.cpp)

# topmg gui main
file(GLOB TOPMG_GUI_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topmg/*.cpp
	                  		   ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topmg/*.qrc
                           ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topmg_argument.cpp
		                  	   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/console_util.cpp)

# topdiff classes
file(GLOB DIFF_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/merge/*.cpp)

file(GLOB DIFF_SEARCH_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/search/duplicatematch/*.cpp)

# topdiff console main
file(GLOB TOPDIFF_PROC_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdiff_process.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdiff_argument.cpp)
file(GLOB TOPDIFF_CONSOLE_SRCS
        ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdiff.cpp)

# topdiff gui main 
file(GLOB TOPDIFF_GUI_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdiff_argument.cpp
                             ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topdiff/*.cpp
		                         ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topdiff/*.qrc)

# topindex classes
file(GLOB FILTER_INDEX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/filter/massmatch/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/filter/mng/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/filter/index/*.cpp)

# topindex console main
file(GLOB TOPINDEX_PROC_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex_process.cpp
                             ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex_argument.cpp)					 

file(GLOB TOPINDEX_CONSOLE_SRCS
        		     ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex.cpp)

# topindex gui main 
file(GLOB TOPINDEX_GUI_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topindex/*.cpp
			                        ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topindex/*.qrc
                              ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex_argument.cpp)


# unit test using catch
file(GLOB UNIT_TEST_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/test/*.cpp)

#gui to run exe in command line
file(GLOB GUI_UTIL_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/util/*.cpp
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/common/util/*.cpp
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/common/base/*.cpp
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/common/xml/*.cpp)

add_executable(topfd 
  ${TOPFD_CONSOLE_SRCS} ${TOPFD_SRCS} ${COMMON_SRCS} ${PARA_SRCS} 
  ${SPEC_SRCS} ${MZML_SRCS} ${PWIZ_SRCS} ${NOWIDE_SRCS})

add_executable(topindex 
  ${TOPINDEX_CONSOLE_SRCS} ${TOPINDEX_PROC_SRCS} ${HTS_SRCS} ${COMMON_SRCS}
  ${SEQ_SRCS} ${PARA_SRCS} ${FILTER_INDEX_SRCS}) 

add_executable(toppic 
	${TOPPIC_CONSOLE_SRCS} ${TOPPIC_PROC_SRCS} ${HTS_SRCS} ${COMMON_SRCS} 
  ${SEQ_SRCS} ${PARA_SRCS} ${SPEC_SRCS}  
  ${PRSM_SRCS} ${FILTER_SRCS} ${SEARCH_SRCS}  
  ${TDGF_SRCS} ${LOCAL_SRCS} ${VISUAL_SRCS})

add_executable(topmg 
	${TOPMG_CONSOLE_SRCS} ${TOPMG_PROC_SRCS} ${HTS_SRCS} ${COMMON_SRCS}
  ${SEQ_SRCS} ${PARA_SRCS} ${SPEC_SRCS} ${PRSM_SRCS} ${FILTER_SRCS} 
	${GRAPH_ALIGN_SRCS} ${MCMC_SRCS} ${VISUAL_SRCS})

add_executable(topdiff 
  ${TOPDIFF_CONSOLE_SRCS} ${TOPDIFF_PROC_SRCS} ${HTS_SRCS} ${COMMON_SRCS} ${DIFF_SEARCH_SRCS}
  ${SEQ_SRCS} ${PARA_SRCS} ${SPEC_SRCS} ${PRSM_SRCS} ${DIFF_SRCS})

add_executable(topfd_gui ${TOPFD_GUI_SRCS} ${GUI_UTIL_SRCS})

add_executable(topindex_gui ${TOPINDEX_GUI_SRCS} ${GUI_UTIL_SRCS})

add_executable(toppic_gui ${TOPPIC_GUI_SRCS} ${GUI_UTIL_SRCS})

add_executable(topmg_gui ${TOPMG_GUI_SRCS} ${GUI_UTIL_SRCS})

add_executable(topdiff_gui ${TOPDIFF_GUI_SRCS} ${GUI_UTIL_SRCS})

IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

  add_library(onnx_lib SHARED IMPORTED)
  set_property(TARGET onnx_lib PROPERTY IMPORTED_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/lib/windows/onnxruntime.dll)
  set_property(TARGET onnx_lib PROPERTY IMPORTED_IMPLIB ${CMAKE_CURRENT_SOURCE_DIR}/lib/windows/onnxruntime.lib)
  
  target_link_libraries(topfd xerces-c
    boost_program_options-mt boost_filesystem-mt
    boost_system-mt boost_thread-mt
    boost_iostreams-mt boost_chrono-mt pthread z psapi Ws2_32 onnx_lib)

  target_link_libraries(topindex xerces-c boost_program_options-mt
    boost_serialization-mt boost_filesystem-mt boost_system-mt boost_thread-mt pthread z Ws2_32)

  target_link_libraries(toppic xerces-c
    boost_filesystem-mt boost_system-mt 
    boost_serialization-mt
    boost_program_options-mt boost_thread-mt pthread z Ws2_32)

  target_link_libraries(topmg xerces-c
    boost_filesystem-mt boost_system-mt boost_serialization-mt
    boost_program_options-mt boost_thread-mt pthread z Ws2_32)

  target_link_libraries(topdiff xerces-c boost_program_options-mt
    boost_filesystem-mt boost_system-mt boost_thread-mt pthread z Ws2_32)

  # for Qt
  SET(QTOPTION -Wl,-subsystem,windows)
  target_link_libraries(topfd_gui ${QTOPTION} Qt5Widgets Qt5Core Qt5Gui
    xerces-c boost_filesystem-mt boost_system-mt boost_thread-mt 
    boost_iostreams-mt boost_chrono-mt pthread z psapi Ws2_32)

  target_link_libraries(topindex_gui ${QTOPTION} Qt5Widgets Qt5Core Qt5Gui xerces-c
    boost_filesystem-mt boost_system-mt boost_serialization-mt 
    boost_program_options-mt boost_thread-mt pthread z Ws2_32)

  target_link_libraries(toppic_gui ${QTOPTION} Qt5Widgets Qt5Core Qt5Gui xerces-c
    boost_filesystem-mt boost_system-mt 
    boost_serialization-mt
    boost_program_options-mt boost_thread-mt pthread z Ws2_32)

  target_link_libraries(topmg_gui ${QTOPTION} Qt5Widgets Qt5Core Qt5Gui xerces-c
    boost_filesystem-mt boost_system-mt boost_serialization-mt
    boost_program_options-mt boost_thread-mt pthread z Ws2_32)

  target_link_libraries(topdiff_gui ${QTOPTION} Qt5Widgets Qt5Core Qt5Gui xerces-c

=== debian/changelog ===
toppic (1.7.10+cleaned1-2) unstable; urgency=low

  * Remove no more dependees from Depends for toppic-common.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 03 Nov 2025 16:54:16 +0100

toppic (1.7.10+cleaned1-1) unstable; urgency=low

  * New upstream version.

  * Repackaged source tree to actually remove unused code and other stuff,
    like .github...

  * Updated patches to use the Debian official packages for a number
    of libraries and install stuff at proper Debian-compatible locations.

  * Standards-Version: 4.7.2

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 20 Oct 2025 12:32:04 +0200

toppic (1.6.1+dfsg1-1) unstable; urgency=low

  * New upstream version.
  * Repackaged source tree to actually remove doc/wiki.
  * Standards-Version: 4.6.2

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 15 Jun 2023 16:24:14 +0200

=== debian/control ===
Source: toppic
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkgconf,
               libhts-dev,
               libboost1.88-dev,
               libboost-filesystem1.88-dev,
               libboost-program-options1.88-dev,
               libboost-thread1.88-dev,
               libboost-system1.88-dev,
               libboost-iostreams1.88-dev,
               libboost-chrono1.88-dev,
               libeigen3-dev,
               libxerces-c-dev,
               qtbase5-dev,
               libpwizlite-dev,
               rapidjson-dev,
               librapidxml-dev,
               libprotobuf-dev,
               libonnx-dev,
               libonnxruntime-dev,
               zlib1g-dev,
# For rst2man
               python3-docutils
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debichem-team/toppic
Vcs-Git: https://salsa.debian.org/debichem-team/toppic.git
Homepage: http://proteomics.informatics.iupui.edu/software/toppic/index.html
Rules-Requires-Root: no

Package: toppic
Architecture: any
Depends: xalan,
         ${shlibs:Depends},
         ${misc:Depends},
         toppic-common (= ${source:Version})
Description: Top-down proteoform identification and characterization (programs)
 The TopPIC Suite consists of four software tools for the interpretation
 of top-down mass spectrometry data: TopFD, TopPIC, TopMG, and TopDiff.
 .
  -TopFD (Top-down mass spectral Feature Detection) is a software tool
    for top-down spectral deconvolution and a successor to MS-Deconv.  It
    groups top-down spectral peaks into isotopomer envelopes and converts
    isotopomer envelopes to monoisotopic neutral masses. In addition, it
    extracts proteoform features from LC-MS or CE-MS data.
 .
  -TopPIC (Top-down mass spectrometry based Proteoform Identification
    and Characterization) identifies and characterizes proteoforms at the
    proteome level by searching top-down tandem mass spectra against a
    protein sequence database. TopPIC is a successor to MS-Align+. It
    efficiently identifies proteoforms with unexpected alterations, such
    as mutations and post-translational modifications (PTMs), accurately
    estimates the statistical significance of identifications, and
    characterizes reported proteoforms with unknown mass shifts. It uses
    several techniques, such as indexes, spectral alignment, generation
    function methods, and the modification identification score (MIScore),
    to increase the speed, sensitivity, and accuracy.
 .
  -TopMG (Top-down mass spectrometry based proteoform identification
    using Mass Graphs) is a software tool for identifying ultra-modified
    proteoforms by searching top-down tandem mass spectra against a
    protein sequence database.  It is capable of identifying proteoforms
    with multiple variable PTMs and unexpected alterations, such as
    histone proteoforms and phosphorylated ones.  It uses mass graphs,
    which efficiently represent candidate proteoforms with multiple
    variable PTMs, to increase the speed and sensitivity in proteoform
    identification. In addition, approximate spectrum-based filtering
    methods are employed for protein sequence filtering, and a Markov
    chain Monte Carlo method (TopMCMC) is used for estimating the
    statistical significance of identifications.
 .
  -TopDiff (Top-down mass spectrometry-based identification of
    Differentially expressed proteoforms) compares the abundances of
    proteoforms and finds differentially expressed proteoforms by using
    identifications of top-down mass spectrometry data of several protein
    samples.

Package: toppic-common
Architecture: all
Depends: ${misc:Depends}
Description: Top-down proteoform identification and characterization (common data)
 The TopPIC Suite consists of four software tools for the interpretation
 of top-down mass spectrometry data: TopFD, TopPIC, TopMG, and TopDiff.
 .
  -TopFD (Top-down mass spectral Feature Detection) is a software tool
    for top-down spectral deconvolution and a successor to MS-Deconv.  It
    groups top-down spectral peaks into isotopomer envelopes and converts
    isotopomer envelopes to monoisotopic neutral masses. In addition, it
    extracts proteoform features from LC-MS or CE-MS data.
 .
  -TopPIC (Top-down mass spectrometry based Proteoform Identification
    and Characterization) identifies and characterizes proteoforms at the
    proteome level by searching top-down tandem mass spectra against a
    protein sequence database. TopPIC is a successor to MS-Align+. It
    efficiently identifies proteoforms with unexpected alterations, such
    as mutations and post-translational modifications (PTMs), accurately
    estimates the statistical significance of identifications, and
    characterizes reported proteoforms with unknown mass shifts. It uses
    several techniques, such as indexes, spectral alignment, generation
    function methods, and the modification identification score (MIScore),
    to increase the speed, sensitivity, and accuracy.
 .
  -TopMG (Top-down mass spectrometry based proteoform identification
    using Mass Graphs) is a software tool for identifying ultra-modified
    proteoforms by searching top-down tandem mass spectra against a
    protein sequence database.  It is capable of identifying proteoforms
    with multiple variable PTMs and unexpected alterations, such as
    histone proteoforms and phosphorylated ones.  It uses mass graphs,
    which efficiently represent candidate proteoforms with multiple
    variable PTMs, to increase the speed and sensitivity in proteoform
    identification. In addition, approximate spectrum-based filtering
    methods are employed for protein sequence filtering, and a Markov
    chain Monte Carlo method (TopMCMC) is used for estimating the
    statistical significance of identifications.
 .
  -TopDiff (Top-down mass spectrometry-based identification of
    Differentially expressed proteoforms) compares the abundances of
    proteoforms and finds differentially expressed proteoforms by using
    identifications of top-down mass spectrometry data of several protein
    samples.
 .
 This package ships common data used by the various program in the
 toppic package and some documentation.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:

	rm -f debian/topfd.1
	rm -f debian/toppic.1
	rm -f debian/topmg.1
	rm -f debian/topdiff.1

	rm -rf obj-x86_64-linux-gnu

	dh_clean


override_dh_auto_configure:

	rst2man debian/topfd.1.rst > debian/topfd.1
	rst2man debian/toppic.1.rst > debian/toppic.1
	rst2man debian/topmg.1.rst > debian/topmg.1
	rst2man debian/topdiff.1.rst > debian/topdiff.1

	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=release

## toppic 1.8.0+repack1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(CMAKE_VERBOSE_MAKEFILE ON)

# Use clang++ as the compiler
find_program(CLANG_EXECUTABLE clang)
find_program(CLANGXX_EXECUTABLE clang++)
set(CMAKE_C_COMPILER clang CACHE STRING "C compiler" FORCE)
set(CMAKE_CXX_COMPILER clang++ CACHE STRING "C++ compiler" FORCE)

project(TopPIC_Suite)
message(STATUS "Project name: " ${PROJECT_NAME})

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/../bin)

message(STATUS "System name: " ${CMAKE_SYSTEM_NAME})

# C++ flags 
# -Wall is used to enable all compiler warnings 
# -Wno-unknown-pragmas is used to disable pragmas warnings 
# -DWITHOUT_MZ5 is used in pwiz to exclude code for mz5 format support
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-unknown-pragmas --std=c++17 -O3 -DWITHOUT_MZ5")

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DTOPPIC_LINUX")
  # --disable-new-dtags is needed to first search the shared library in the lib/toppic directory
  SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,-rpath=$ORIGIN/../lib/toppic,--disable-new-dtags")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux") 

IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  # fpermissive is needed to compile ext/pwiz/utility/misc/Filesystem.cpp
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -DTOPPIC_WINDOWS -DWIN32")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

message(STATUS "Cmake cxx flags: " ${CMAKE_CXX_FLAGS})

# Qt
set(CMAKE_AUTOMOC ON)
SET(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
find_package(Boost 1.74 REQUIRED)
find_package(Qt5Widgets)
find_package(Qt5Core)
find_package(Qt5Gui)


include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext
                    ${Qt5Widgets_INCLUDE_DIRS}
                    ${Qt5Core_INCLUDE_DIRS}
                    ${Qt5Gui_INCLUDE_DIRS})

link_directories(${CMAKE_CURRENT_SOURCE_DIR}/lib/toppic)

# pwiz 
file(GLOB PWIZ_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/utility/minimxml/*.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/utility/misc/*.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/data/common/*.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/data/msdata/*.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/ext/pwiz/data/msdata/mzmlb/*.cpp)

# hts 
file(GLOB HTS_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/ext/htslib/*.c)

# nowide source code used for the Windows version of TopFD
file(GLOB NOWIDE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/ext/boost/nowide/*.c)

# code shared by several executables
file(GLOB_RECURSE COMMON_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/common/*.cpp)

file(GLOB SQL_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/sql/*.cpp)


file(GLOB SEQ_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/seq/*.cpp)
file(GLOB PARA_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/para/*.cpp)
file(GLOB SPEC_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/spec/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/msmap/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/factory/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/env/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/feature/*.cpp)
file(GLOB MZML_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/ms/mzml/*.cpp)
file(GLOB PRSM_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/prsm/*.cpp)

# gui code to run exe in command line
file(GLOB GUI_UTIL_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/util/*.cpp
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/common/util/*.cpp
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/common/base/*.cpp
                        ${CMAKE_CURRENT_SOURCE_DIR}/src/common/xml/*.cpp)


# topfd 
file(GLOB_RECURSE TOPFD_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/topfd/*.cpp)

# topfd console 
file(GLOB TOPFD_CONSOLE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topfd_argument.cpp
                             ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topfd.cpp)

# topfd gui
file(GLOB TOPFD_GUI_SRCS    ${CMAKE_CURRENT_SOURCE_DIR}/src/topfd/common/topfd_para.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topfd/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topfd/*.qrc)

# topindex 
file(GLOB FILTER_INDEX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/filter/massmatch/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/filter/mng/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/filter/index/*.cpp)

# topindex console
file(GLOB TOPINDEX_PROC_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex_process.cpp
                             ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex_argument.cpp)					 

file(GLOB TOPINDEX_CONSOLE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex.cpp)

# topindex gui  
file(GLOB TOPINDEX_GUI_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topindex/*.cpp
			                        ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topindex/*.qrc
                              ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex_argument.cpp)

# toppic
file(GLOB_RECURSE FILTER_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/filter/*.cpp)

file(GLOB SEARCH_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/search/diag/*.cpp 
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/zeroptmsearch/*.cpp
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/oneptmsearch/*.cpp
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/varptmsearch/*.cpp
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/ptmsearch/*.cpp
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/search/duplicatematch/*.cpp)

file(GLOB TDGF_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/count/*.cpp
                      ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/tdgf/*.cpp)
file(GLOB LOCAL_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/local/*.cpp)
file(GLOB VISUAL_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/visual/*.cpp)

# toppic console
file(GLOB TOPPIC_PROC_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/console/toppic_process.cpp
		                  	    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/toppic_argument.cpp
		                  	    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/console_util.cpp)

file(GLOB TOPPIC_CONSOLE_SRCS	${CMAKE_CURRENT_SOURCE_DIR}/src/console/toppic.cpp)

# toppic gui 
file(GLOB TOPPIC_GUI_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/toppic/*.cpp
	                  		    ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/toppic/*.qrc
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/console/toppic_argument.cpp
		                  	    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/console_util.cpp)

# topmg
file(GLOB GRAPH_ALIGN_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/search/diag/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/search/graph/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/search/graphalign/*.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/search/duplicatematch/*.cpp)

file(GLOB MCMC_SRCS  ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/count/*.cpp
                     ${CMAKE_CURRENT_SOURCE_DIR}/src/stat/mcmc/*.cpp)

# topmg console 
file(GLOB TOPMG_PROC_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topmg_process.cpp
	                  		    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topmg_argument.cpp
                      			${CMAKE_CURRENT_SOURCE_DIR}/src/console/topindex_file_name.cpp
		                  	    ${CMAKE_CURRENT_SOURCE_DIR}/src/console/console_util.cpp)

file(GLOB TOPMG_CONSOLE_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topmg.cpp)

# topmg gui 
file(GLOB TOPMG_GUI_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topmg/*.cpp
	                  		   ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topmg/*.qrc
                           ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topmg_argument.cpp
		                  	   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/console_util.cpp)

# topdiff 
file(GLOB DIFF_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/merge/*.cpp)

file(GLOB DIFF_SEARCH_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/search/duplicatematch/*.cpp)

# topdiff console 
file(GLOB TOPDIFF_PROC_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdiff_process.cpp
                            ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdiff_argument.cpp)
file(GLOB TOPDIFF_CONSOLE_SRCS
        ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdiff.cpp)

# topdiff gui  
file(GLOB TOPDIFF_GUI_SRCS   ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdiff_argument.cpp
                             ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topdiff/*.cpp
		                         ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topdiff/*.qrc)

# topdia
file(GLOB_RECURSE TOPDIA_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/topdia/*.cpp)

# topdia console
file(GLOB TOPDIA_CONSOLE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdia_argument.cpp
                              ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdia.cpp)

# topdia gui
file(GLOB TOPDIA_GUI_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/console/topdia_argument.cpp
                          ${CMAKE_CURRENT_SOURCE_DIR}/src/topfd/common/topfd_para.cpp
                          ${CMAKE_CURRENT_SOURCE_DIR}/src/topdia/common/topdia_para.cpp
                          ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topdia/*.cpp
                          ${CMAKE_CURRENT_SOURCE_DIR}/src/gui/topdia/*.qrc)

# unit test 
file(GLOB UNIT_TEST_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/test/*.cpp)

add_executable(topfd 
  ${TOPFD_CONSOLE_SRCS} ${TOPFD_SRCS} ${COMMON_SRCS} ${SQL_SRCS} ${PARA_SRCS} 
  ${SPEC_SRCS} ${MZML_SRCS} ${PWIZ_SRCS} ${NOWIDE_SRCS})

add_executable(topindex 
  ${TOPINDEX_CONSOLE_SRCS} ${TOPINDEX_PROC_SRCS} ${HTS_SRCS} ${COMMON_SRCS}
  ${SEQ_SRCS} ${PARA_SRCS} ${FILTER_INDEX_SRCS}) 

add_executable(toppic 
	${TOPPIC_CONSOLE_SRCS} ${TOPPIC_PROC_SRCS} ${HTS_SRCS} ${COMMON_SRCS} 
  ${SEQ_SRCS} ${PARA_SRCS} ${SPEC_SRCS}  
  ${PRSM_SRCS} ${FILTER_SRCS} ${SEARCH_SRCS}  
  ${TDGF_SRCS} ${LOCAL_SRCS} ${VISUAL_SRCS})

add_executable(topmg 
	${TOPMG_CONSOLE_SRCS} ${TOPMG_PROC_SRCS} ${HTS_SRCS} ${COMMON_SRCS}
  ${SEQ_SRCS} ${PARA_SRCS} ${SPEC_SRCS} ${PRSM_SRCS} ${FILTER_SRCS} 
	${GRAPH_ALIGN_SRCS} ${MCMC_SRCS} ${VISUAL_SRCS})

add_executable(topdiff 
  ${TOPDIFF_CONSOLE_SRCS} ${TOPDIFF_PROC_SRCS} ${HTS_SRCS} ${COMMON_SRCS} 
  ${DIFF_SEARCH_SRCS} ${SEQ_SRCS} ${PARA_SRCS} ${SPEC_SRCS} ${PRSM_SRCS} 
  ${DIFF_SRCS})

add_executable(topdia
  ${TOPDIA_CONSOLE_SRCS} ${TOPDIA_SRCS} ${COMMON_SRCS} ${SQL_SRCS} ${PARA_SRCS}
  ${SPEC_SRCS} ${MZML_SRCS} ${TOPFD_SRCS} ${PWIZ_SRCS} ${NOWIDE_SRCS})

add_executable(topfd_gui ${TOPFD_GUI_SRCS} ${GUI_UTIL_SRCS} ${SQL_SRCS})

add_executable(topindex_gui ${TOPINDEX_GUI_SRCS} ${GUI_UTIL_SRCS})

add_executable(toppic_gui ${TOPPIC_GUI_SRCS} ${GUI_UTIL_SRCS})

add_executable(topmg_gui ${TOPMG_GUI_SRCS} ${GUI_UTIL_SRCS})

add_executable(topdiff_gui ${TOPDIFF_GUI_SRCS} ${GUI_UTIL_SRCS})

add_executable(topdia_gui ${TOPDIA_GUI_SRCS} ${GUI_UTIL_SRCS} ${SQL_SRCS})

IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  # onnx runtime library
  add_library(onnx_lib SHARED IMPORTED)
  set_property(TARGET onnx_lib PROPERTY IMPORTED_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/lib/windows/onnxruntime.dll)
  set_property(TARGET onnx_lib PROPERTY IMPORTED_IMPLIB ${CMAKE_CURRENT_SOURCE_DIR}/lib/windows/onnxruntime.lib)

  target_link_libraries(topfd boost_chrono-mt boost_filesystem-mt
    boost_program_options-mt boost_iostreams-mt boost_thread-mt
    boost_nowide-mt xerces-c sqlite3 z psapi Ws2_32 onnx_lib)

  target_link_libraries(topindex boost_program_options-mt
    boost_serialization-mt boost_thread-mt xerces-c z Ws2_32)

  target_link_libraries(toppic boost_program_options-mt
    boost_serialization-mt boost_thread-mt xerces-c z Ws2_32)

  target_link_libraries(topmg boost_program_options-mt
    boost_serialization-mt boost_thread-mt xerces-c z Ws2_32)

  target_link_libraries(topdiff boost_program_options-mt
    boost_thread-mt xerces-c z Ws2_32)

  target_link_libraries(topdia boost_chrono-mt boost_filesystem-mt
    boost_program_options-mt boost_iostreams-mt boost_thread-mt
    boost_nowide-mt xerces-c sqlite3 z psapi Ws2_32 onnx_lib)

  # Qt

=== debian/changelog ===
toppic (1.8.0+repack1-1) unstable; urgency=low

  * New upstream release.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 13 Nov 2025 23:22:42 +0100

=== debian/control ===
--- 
+++ 
@@ -4,28 +4,31 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               cmake,
-               pkgconf,
-               libhts-dev,
-               libboost1.88-dev,
-               libboost-filesystem1.88-dev,
-               libboost-program-options1.88-dev,
-               libboost-thread1.88-dev,
-               libboost-system1.88-dev,
-               libboost-iostreams1.88-dev,
-               libboost-chrono1.88-dev,
-               libeigen3-dev,
-               libxerces-c-dev,
-               qtbase5-dev,
-               libpwizlite-dev,
-               rapidjson-dev,
-               librapidxml-dev,
-               libprotobuf-dev,
-               libonnx-dev,
-               libonnxruntime-dev,
-               zlib1g-dev,
+ clang,
+ cmake,
+ pkgconf,
+ quilt,
+ libhts-dev,
+ libboost1.88-dev,
+ libboost-filesystem1.88-dev,
+ libboost-program-options1.88-dev,
+ libboost-thread1.88-dev,
+ libboost-system1.88-dev,
+ libboost-iostreams1.88-dev,
+ libboost-chrono1.88-dev,
+ libeigen3-dev,
+ libsqlite3-dev,
+ libxerces-c-dev,
+ qtbase5-dev,
+ libpwizlite-dev,
+ rapidjson-dev,
+ librapidxml-dev,
+ libprotobuf-dev,
+ libonnx-dev,
+ libonnxruntime-dev,
+ zlib1g-dev,
 # For rst2man
-               python3-docutils
+ python3-docutils
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debichem-team/toppic
 Vcs-Git: https://salsa.debian.org/debichem-team/toppic.git

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,8 @@
 
 override_dh_auto_clean:
 
+	dh_quilt_unpatch
+
 	rm -f debian/topfd.1
 	rm -f debian/toppic.1
 	rm -f debian/topmg.1
@@ -23,10 +25,16 @@
 
 override_dh_auto_configure:
 
+	dh_quilt_patch
+
 	rst2man debian/topfd.1.rst > debian/topfd.1
 	rst2man debian/toppic.1.rst > debian/toppic.1
 	rst2man debian/topmg.1.rst > debian/topmg.1
 	rst2man debian/topdiff.1.rst > debian/topdiff.1
 
 	dh_auto_configure -- \
-		-DCMAKE_BUILD_TYPE=release
+		-DCMAKE_BUILD_TYPE=Release
+
+override_dh_dwz:
+	echo "Skipping dh_dwz because of Unknown debugging section .debug_addr error."
+	# dh_dwz --no-dwz-multifile

=== debian/watch ===
version=4

opts="repack, \
repacksuffix=+repack, \
compression=gzip, \
dversionmangle=s/\+repack\d*$//, \
filenamemangle=s%(?:.*?)?v?(\d[\d\.]*)\.tar\.gz%toppic-$1.tar.gz%" \
https://github.com/toppic-suite/toppic-suite/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
